﻿using System;
using UnityEngine;

[Serializable]
public class BackgroundLandscapeDescriptor : System.Object
{
    [SerializeField]
    private Sprite m_Sprite = null;
    private Sprite Sprite
    {
        get { return m_Sprite; }
    }

    public void Generate(Transform attachmentPoint, ref int sortingOrder, float widthInUnits )
    {
        var w = Sprite.bounds.size.x;
        var h = Sprite.bounds.size.y;

        var curX = -widthInUnits / 2.0f + w/2.0f;

        int c = 0;
        while (curX < widthInUnits / 2.0f)
        {
            var newGo = new GameObject(String.Format("BG_{0}", c));
            newGo.transform.SetParent(attachmentPoint, false);

            var spriteRenderer = newGo.AddComponent<SpriteRenderer>();
            spriteRenderer.sprite = Sprite;
            spriteRenderer.transform.localPosition = new Vector2(curX, 0.0f);

            spriteRenderer.sortingOrder = sortingOrder--;

            c++;
            curX += Sprite.bounds.size.x;
        }
    }
}

